/*
	(C) 2001 AROS - The Amiga Research OS
	$Id: global.h,v 1.19 2018/02/25 17:09:00 piru Exp $

	Desc:
	Lang: English
*/

#ifndef GLOBAL_H
#define GLOBAL_H

/*********************************************************************************************/

#define	USE_DELAYEDREOPENWB		1

/*********************************************************************************************/

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef DOS_NOTIFY_H
#include <dos/notify.h>
#endif

#ifndef DOS_DOSTAGS_H
#include <dos/dostags.h>
#endif

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#ifndef INTUITION_SCREENS_H
#include <intuition/screens.h>
#endif

#ifndef INTUITION_IMAGECLASS_H
#include <intuition/imageclass.h>
#endif

#ifndef INTUITION_GADGETCLASS_H
#include <intuition/gadgetclass.h>
#endif

#ifndef INTUITION_CLASSUSR_H
#include <intuition/classusr.h>
#endif

#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif

#ifndef INTUITION_ICCLASS_H
#include <intuition/icclass.h>
#endif

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif

#ifndef GRAPHICS_GFXBASE_H
#include <graphics/gfxbase.h>
#endif

#ifndef GRAPHICS_CLIP_H
#include <graphics/clip.h>
#endif

#ifndef GRAPHICS_LAYERS_H
#include <graphics/layers.h>
#endif

#ifndef DEVICES_KEYMAP_H
#include <devices/keymap.h>
#endif

#ifndef DEVICES_INPUTEVENT_H
#include <devices/inputevent.h>
#endif

#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

#ifndef LIBRARIES_ASL_H
#include <libraries/asl.h>
#endif

#ifndef UTILITY_UTILITY_H
#include <utility/utility.h>
#endif

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

#ifndef LIBRARIES_LOCALE_H
#include <libraries/locale.h>
#endif

#ifndef DATATYPES_DATATYPES_H
#include <datatypes/datatypes.h>
#endif

#ifndef DATATYPES_DATATYPESCLASS_H
#include <datatypes/datatypesclass.h>
#endif

#ifndef DATATYPES_PICTURECLASS_H
#include <datatypes/pictureclass.h>
#endif

#ifndef PREFS_PREFHDR_H
#include <prefs/prefhdr.h>
#endif

#ifndef PREFS_SCREENMODE_H
#include <prefs/screenmode.h>
#endif

#ifndef PREFS_POINTER_H
#include <prefs/pointer.h>
#endif

#ifndef PREFS_INPUT_H
#include <prefs/input.h>
#endif

#ifndef PREFS_LOCALE_H
#include <prefs/locale.h>
#endif

#ifndef PREFS_FONT_H
#include <prefs/font.h>
#endif

#ifndef PREFS_PALETTE_H
#include <prefs/palette.h>
#endif

#ifndef PREFS_WBPATTERN_H
#include <prefs/wbpattern.h>
#endif

#ifndef PREFS_SOUND_H
#include <prefs/sound.h>
#endif

#ifndef PREFS_ICONTROL_H
#include <prefs/icontrol.h>
#endif

#ifndef PREFS_WORKBENCH_H
#include <prefs/workbench.h>
#endif

#ifndef PREFS_REACTION_H
#include <prefs/reaction.h>
#endif

#ifndef PREFS_SERIAL_H
#include <prefs/serial.h>
#endif

#ifndef PREFS_BLANKER_H
#include <prefs/blanker.h>
#endif

#include <private/prefs/network.h>

#ifndef PREFS_PRINTERGFX_H
#include <prefs/printergfx.h>
#endif

#ifndef PREFS_PRINTERTXT_H
#include <prefs/printertxt.h>
#endif

#include <libraries/poseidon.h>
#include <libraries/query.h>

/*********************************************************************************************/

#ifndef PROTO_EXEC_H
#include <proto/exec.h>
#endif

#ifndef PROTO_DOS_H
#include <proto/dos.h>
#endif

#ifndef PROTO_INTUITION_H
#include <proto/intuition.h>
#endif

#ifndef PROTO_GRAPHICS_H
#include <proto/graphics.h>
#endif

#ifndef PROTO_UTILITY_H
#include <proto/utility.h>
#endif

#ifndef PROTO_KEYMAP_H
#include <proto/keymap.h>
#endif

#ifndef PROTO_LOCALE_H
#include <proto/locale.h>
#endif

#ifndef PROTO_LAYERS_H
#include <proto/layers.h>
#endif

#ifndef PROTO_DATATYPES_H
#include <proto/datatypes.h>
#endif

#ifndef PROTO_LOG_H
#include <proto/log.h>
#endif

#ifndef PROTO_ALIB_H
//#include <proto/alib.h>
#endif

#include <proto/cybergraphics.h>
#include <cybergraphx/cybergraphics.h>


#ifndef PROTO_ASL_H
#include <proto/asl.h>
#endif

#ifndef PROTO_DISKFONT_H
#include <proto/diskfont.h>
#endif

#ifndef PROTO_WB_H
#include <proto/wb.h>
#endif

#ifndef PROTO_IFFPARSE_H
#include <proto/iffparse.h>
#endif

#include <proto/poseidon.h>
#include <proto/query.h>
#include <proto/muimaster.h>

#include <aros/asmcall.h>
#include <aros/libcall.h>

#include <private/prefs/setiprefs.h>


#ifdef __MORPHOS__
void	dprintf(char *, ...) __attribute__ ((format (printf, 1, 2)));
#else
#include <string.h>
#define memclr(a,b) bzero(a,b)
#endif


/*********************************************************************************************/

#define IPREFS_SEM_NAME " IPrefs "

struct IPrefsSem
{
	struct SignalSemaphore sem;
	UBYTE   	    	   semname[12];
};

/*********************************************************************************************/

#pragma pack(2) /* Makes no diff with 68k vs ppc, but better have it anyway - Piru */

struct WBFontPrefs
{
	struct TextAttr *TextAttrPtr;
	struct TextFont *TextFont;
	UWORD DrawMode;
	UBYTE FrontPen;
	UBYTE BackPen;
	struct TextAttr TextAttr;
	UBYTE Name[1];
};

#pragma pack()

#define SetIPrefs(__p0, __p1, __p2) \
	LP3(96*6, ULONG, SetIPrefs, \
		APTR , __p0, a0, \
		LONG , __p1, d0, \
		LONG , __p2, d1, \
		, INTUITION_BASE_NAME, 0, 0, 0, 0, 0, 0)

#ifndef WBConfig
#define WBConfig(__p0, __p1) \
	LP2(14*6, void *, WBConfig, \
		ULONG , __p0, d0, \
		APTR , __p1, d1, \
		, WB_BASE_NAME, 0, 0, 0, 0, 0, 0)
#endif

#define LocalePrefsUpdate(__p0) \
	LP1(28*6, void * , LocalePrefsUpdate, \
		struct Locale *, __p0, a0, \
		, LOCALE_BASE_NAME, 0, 0, 0, 0, 0, 0)


/*********************************************************************************************/

#include "vars.h"

/*********************************************************************************************/

/* main.c */

void Cleanup(STRPTR msg);

/* patches.c */

void InstallPatches(void);

/* localeprefs.c */

AROS_UFP1(LONG, LocalePrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* screenprefs.c */

AROS_UFP1(LONG, ScreenPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, MUIScreenPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

void LoadScreenPrefs(char *filename);

/* inputprefs.c */

AROS_UFP1(LONG, InputPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, InputPrefsExt_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, InputMousePrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, InputKeyboardPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

void LoadKeyboardPrefs(char *filename);
void LoadMousePrefs(char *filename);

/* fontprefs.c */

AROS_UFP1(LONG, FontPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* paletteprefs.c */

AROS_UFP1(LONG, PalettePrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* pointerprefs.c */

AROS_UFP1(LONG, PointerPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* wbpattern.c */

AROS_UFP1(LONG, WBPatternPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

void	LoadPatterns(void);

/* sound.c */

AROS_UFP1(LONG, SoundPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

void PlayBeep(void);

void InstallDisplayBeepPatch(void);

/* icontrolprefs.c */

AROS_UFP1(LONG, IControlPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, IControlExtensions_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, IControlActions_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, IControlHotkeys_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

void LoadIControl(char *filename);

/* workbenchprefs.c */

AROS_UFP1(LONG, WorkbenchPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, WorkbenchHiddenDevicePrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));


/* reactionprefs.c */

AROS_UFP1(LONG, ReactionPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* blankerprefs.c */
AROS_UFP1(LONG, BlankerPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* poseidon.c */
void LoadPoseidonPrefs(char *filename);

/* serialprefs.c */

AROS_UFP1(LONG, SerialPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* networkprefs.c */

void LoadNetworkPrefs(char *filename);

/* tzprefs.c */

void SetupTZHandler(void);

/* userprefs.c */

void LoadUserPrefs(char *filename);

/* logserverprefs.c */

void LoadLogServerPrefs(char *filename);

/* compositing.c */
void LoadCompositingPrefs(char *filename);

/* powerbook.c */
void LoadPowerBookPrefs(char *filename);

/* diskcache.c */
void LoadDiskCachePrefs(char *filename);

/* new font.c */
void LoadFontPrefs(char *filename);

/* new blanker.c */
void LoadBlankerPrefs(char *filename);

/* printerprefs.c */

AROS_UFP1(LONG, PrinterTxtPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

AROS_UFP1(LONG, PrinterUnitPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

/* printergfxprefs.c */

AROS_UFP1(LONG, PrinterGfxPrefs_Handler,
	AROS_UFPA(struct IFFHandle *, iff, A2));

BOOL CheckForNetstack(void);
void StartNetwork(void);
/*********************************************************************************************/

#endif /* GLOBAL_H */
